### compiler
ARM GNU Toolchain 4.8.2 for Cortex-A

### patch
if <package>_patch directory exists, copy the <package>_patch files 
over top of the files in <package_directory> before building

### dependencies
*zlib-1.2.3\**  \
*jpeg-6b\**  \
*libpng-1.2.43\**  \
*freetype-2.3.9\** \
libicu (Make sure the package include libicu directory.)

**[make - zlib]**
```
export CROSS_COMPILE_GCC=arm-linux-gnueabi-gcc
export CROSS_COMPILE_LD=arm-linux-gnueabi-ld
export CROSS_COMPILE_AR=arm-linux-gnueabi-ar
export CC=${CROSS_COMPILE_GCC} LD=${CROSS_COMPILE_LD} AR=${CROSS_COMPILE_AR}
./configure --prefix=</path/to/zlib-output> --shared
make
make install
```

**[make - libpng]**
```
export CROSS_COMPILE_GCC=arm-linux-gnueabi-gcc
export CROSS_COMPILE_LD=arm-linux-gnueabi-ld
export CROSS_COMPILE_AR=arm-linux-gnueabi-ar
export CC=${CROSS_COMPILE_GCC} LD=${CROSS_COMPILE_LD} AR=${CROSS_COMPILE_AR}
export LDFLAGS=-L</path/to/zlib-output>/lib/
export CFLAGS=-I</path/to/zlib-output>/include/
export CPPFLAGS=-I</path/to/zlib-output>/include/
./configure --host=arm-linux --prefix=</path/to/libpng-output>
make
make install
```

**[make - freetype]**
```
export CC=arm-linux-gnueabi-gcc
export CXX=arm-linux-gnueabi-g++
export AR=arm-linux-gnueabi-ar
export STRIP=arm-linux-gnueabi-strip
./configure --host=arm-linux --prefix=</path/to/freetype-output>
make install
```

**[make - jpeg-6b]**
```
export CC=arm-linux-gnueabi-gcc
export CXX=arm-linux-gnueabi-g++
export AR=arm-linux-gnueabi-ar
export STRIP=arm-linux-gnueabi-strip
./configure --host=arm-linux --prefix=</path/to/jpeg-output> --enable-shared
make install
```

**[make - JavaScript]**
```
export CROSS_COMPILE_GCC=arm-linux-gnueabi-gcc
export CROSS_COMPILE_GXX=arm-linux-gnueabi-g++
export CROSS_COMPILE_LD=arm-linux-gnueabi-ld
export CROSS_COMPILE_AR=arm-linux-gnueabi-ar
export DEFINES="-D_CPU_LITTLE_ENDIAN_ -DLINUX -D_FILE_OFFSET_BITS=64 -DTARGET_LITTLE_ENDIAN=1 -DSECURE_STORAGE_SUPPORT=1 -DTEE_SECURESTOP=1 -DUSE_FBDEV_EGL -DEGL_FBDEV -DGL_GLEXT_PROTOTYPES -DEGL_EGLEXT_PROTOTYPES"
export INCLUDES="-I</path/to/zlib-output>/include -I</path/to/libpng-output>/include -I</path/to/freetype-output>/include -I</path/to/jpeg-output>/include -I</path/to/libicu>/include -L</path/to/libicu>/lib -licui18n -licuuc -licudata -licuio"
export CFLAGS="-Wall -fPIC -fvisibility=default -pipe -Wno-psabi -fsigned-char ${DEFINES} ${INCLUDES}"
export CXXFLAGS="-Wall -fPIC -fvisibility=default -pipe -Wno-psabi -fsigned-char ${DEFINES} ${INCLUDES}"
export LDFLAGS="-L</path/to/ncurses-output>/output/lib -L</path/to/libicu>/lib -lpthread -Wl,-rpath=/basic:/basic/lib:/lib:/3rd/netflix/nrd-app:/3rd/lib"
export CC=${CROSS_COMPILE_GCC} CXX=${CROSS_COMPILE_GXX} LD=${CROSS_COMPILE_LD} AR=${CROSS_COMPILE_AR}
cmake -DCMAKE_BUILD_TYPE=Release -DGIBBON_SCRIPT_JSC_BACKDOOR=1  -DGIBBON_SCRIPT_JSC_DYNAMIC=1 -DJAVASCRIPTCORE_ARCH=arm  -DCMAKE_CXX_COMPILER=${CROSS_COMPILE_GXX} -DCMAKE_C_COMPILER=${CROSS_COMPILE_GCC} -DCMAKE_CXX_FLAGS_RELEASE="-O2 -DNDEBUG" -DCMAKE_C_FLAGS_RELEASE="-O2 -DNDEBUG"
make
mkdir -p /home/oss/target_rootfs/3rd/netflix/nrd-app/
cp Source/JavaScriptCore/libJavaScriptCore.so /home/oss/target_rootfs/3rd/netflix/nrd-app/
```
